package main

import (
	"KuaiYanGoSdk/KuaiYanSdk"
	"KuaiYanGoSdk/utils"
	"fmt"
	"os"
	"sync"
	"time"
)

/*设置包自动管理*/
//go:generate go env -w GO111MODULE=on

/*设置包管理下载地址*/
//go:generate go env -w GOPROXY=https://goproxy.cn,direct

/*设置包自动整理信息到go.mod内*/
//go:generate go mod tidy

/*设置包自动根据go.mod下载*/
//go:generate go mod download

var Ky KuaiYanSdk.Api快验_类 //全局变量
var wg sync.WaitGroup

func main() {
	fmt.Print("飞鸟快验对接例子,官网 www.fnkuaiyan.cn\n")
	//先初始化配置
	Ky.C初始化配置(`{"AppWeb":"https://demo.fnkuaiyan.cn/Api?AppId=10001","CryptoKeyPublic":"-----BEGIN PUBLIC KEY-----\nMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDHvj3XIapi/OHnta5CdHynI59S\necVJFl2rSW8pxN+o98sVwPkWR8/QVK9g2ieMeyIN3apA9bjIt4C9tAU/N3ZB7aV9\nvt3o76bvxq88pSaXFMmTOXW4qTuS8E7IFMjmzr6P1+SYoHx/W2VwIWExKTzxaamZ\n9fIq8aa/dAhEMFjOIQIDAQAB\n-----END PUBLIC KEY-----\n","CryptoType":3}`)
	var errCode int
	if !Ky.Q取Token() {
		fmt.Printf(Ky.Q取错误信息(&errCode) + "\n")
		return
	}
	fmt.Printf("公共:%v\n", Ky.Q取应用公告(nil))

	var 局_响应信息 string

	if !Ky.Q取开启验证码接口列表(&局_响应信息) {
		fmt.Printf(Ky.Q取错误信息(&errCode) + "\n")
		return
	}
	fmt.Printf("Q取开启验证码接口列表:%v\n", 局_响应信息)

	if !Ky.Q取验证码(&局_响应信息, 1) {
		fmt.Printf(Ky.Q取错误信息(&errCode) + "\n")
		return
	}
	fmt.Printf("Q取开启验证码接口列表:%v\n", 局_响应信息)
	//局_验证码图片 := utils.W文本_取出中间文本(局_响应信息, `"CaptChaImg":"`, `"`)
	局_验证码id := utils.W文本_取出中间文本(局_响应信息, `"CaptchaId":"`, `"`)
	//这里要用户输入正确的验证码值, 这里就随便填写1234 了
	Ky.Z置验证码信息(1, 局_验证码id, "1234") //要提交验证码接口上一行置入验证码,下一次请求,就携带验证码信息了
	if !Ky.D登录_通用(&局_响应信息, "aaaaaa", "aaaaaa", "绑定信息", "动态标记", "1.0.1") {
		fmt.Printf(Ky.Q取错误信息(&errCode) + "\n")
	}

	if !Ky.Q取软件用户信息(&局_响应信息) {
		fmt.Printf(Ky.Q取错误信息(&errCode) + "\n")
		return
	}
	fmt.Printf("Q取软件用户信息:%v\n", 局_响应信息)

	if !Ky.Q取用户基础信息(&局_响应信息) {
		fmt.Printf(Ky.Q取错误信息(&errCode) + "\n")
		return
	}
	fmt.Printf("取用户基础信息:%v\n", 局_响应信息)

	if !Ky.Z置动态标记("我是新动态标记") {
		fmt.Printf(Ky.Q取错误信息(&errCode) + "\n")
		return
	}
	if !Ky.Y云函数运行(&局_响应信息, "测试网页访问", "{}", true) {
		fmt.Printf(Ky.Q取错误信息(&errCode) + "\n")
		return
	}
	fmt.Printf("Y云函数运行:%v\n", 局_响应信息)
	wg.Add(1) // 增加等待组的计数器
	go X心跳()
	wg.Wait() // 等待所有协程退出
	time.Sleep(5 * time.Second)

	Ky.Y用户登录注销()
	fmt.Print("结束")
}

var 心跳容错计次 = 0

func X心跳() {
	defer wg.Done() // 协程执行完毕后减少等待组的计数器
	局_响应信息 := ""
	局_当前状态 := 0
	for true { //死循环心跳
		time.Sleep(60 * time.Second) //60秒一次  按需调整

		if !Ky.X心跳(&局_响应信息, &局_当前状态) {
			心跳容错计次++ //' 容错处理,防网络闪断 之类的,造成用户体验不好 连续3次都异常才处理
			if 心跳容错计次 > 3 {
				os.Exit(0) //超过3次心跳失败,直接结束
			}
		} else {
			心跳容错计次 = 0 //心跳正常,容错归零
			switch 局_当前状态 {
			case 1:
				//会员未过期,或者应用免费模式
				fmt.Printf("心跳正常,会员也未过期")
			case 3:
				//会员已过期
				fmt.Printf("会员已到期, 请充值后重新登录, 感谢您的支持")
				os.Exit(0)
			default:
				fmt.Printf("正常不会有其他结果%d", 局_当前状态)
			}
		}
	}
}
